<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Browse tickets
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}

zero::StartSession("Browse Ticket");
$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];

$request = $_SERVER[QUERY_STRING];

if ($pf) {
	if (substr_count($request,"&pf"))
  	$request = trim(preg_replace("/&pf=[\w\W]*/i", "", $request));
	else
	  $request = trim(preg_replace("/pf=[\w\W]*/i", "", $request));

	if ($pf == "reply")
	  zero::Redirect("ticket_massreply.php?ticket_refs={$ticket_refs}");

  $ticket_refs = explode(";",$ticket_refs);
	if ($pf == "close")
	  zero::CloseTickets($ticket_refs);
	elseif ($pf == "open")
	  zero::OpenTickets($ticket_refs);
	elseif ($pf == "flag")
	  zero::FlagTickets($ticket_refs);
	elseif ($pf == "unflag")
	  zero::UnFlagTickets($ticket_refs);
	elseif ($pf == "lock")
	  zero::LockTickets($ticket_refs);
	elseif ($pf == "unlock")
	  zero::UnLockTickets($ticket_refs);
	elseif ($pf == "ban_email")
	  zero::BanEmailsByTickets($ticket_refs);
	elseif ($pf == "unban_email")
	  zero::UnBanEmailsByTickets($ticket_refs);
	elseif ($pf == "delete")
	  zero::DeleteTickets($ticket_refs);
	if ($request)
		zero::Redirect("ticket_browse.php?".$request);
	else
	  zero::Redirect("ticket_browse.php");
}

$search_words = trim($search_words);
$smarty_tpl->assign("search_words", $search_words);
$search_in_options = array(
													"all"=>"All",
													"ticket_ref"=>"Ticket Ref",
													"subject"=>"Subject",
													"name_email"=>"Name/Email",
													"message"=>"Message"
												);
$smarty_tpl->assign("search_in_options", $search_in_options);
$search_ins = explode(";",$search_ins);
if (!$search_ins[0])
  $search_ins[0] = "all";
$smarty_tpl->assign("search_ins", $search_ins);

$temp_options['all'] 	= "All";
$priority_options = $temp_options + zero::GetPriorityOptions();
$smarty_tpl->assign("priority_options", $priority_options);
$priorities = explode(";",$priorities);
if (!$priorities[0])
  $priorities[0] = "all";
$smarty_tpl->assign("priorities", $priorities);

$department_options = $temp_options + zero::GetDepartmentOptions();
$smarty_tpl->assign("department_options", $department_options);
$departments = explode(";",$departments);
if (!$departments[0])
  $departments[0] = "all";
$smarty_tpl->assign("departments", $departments);

$status_options = array(
													"all"=>"All",
													"open"=>"Open",
													"closed"=>"Closed",
													"flagged"=>"Flagged",
													"locked"=>"Locked"
												);
$smarty_tpl->assign("status_options", $status_options);
$statuses = explode(";",$statuses);
if (!$statuses[0])
  $statuses[0] = "all";
$smarty_tpl->assign("statuses", $statuses);

$smarty_tpl->assign("radio_status", $radio_status?$radio_status:"open");
$smarty_tpl->assign("unread_check", $unread_check);
$smarty_tpl->assign("mypost_check", $mypost_check);


if ($date_created_filter == "within") {
	$time_from_created  	= mktime(0,0,0,date("n"),date("j")-$created_within,date("Y"));
	$time_to_created    	= time();
  $smarty_tpl->assign("date_created_filter", "within");
  $smarty_tpl->assign("created_within", $created_within);
}
elseif ($date_created_filter == "range") {
	$time_from_created  = mktime(0,0,0,$from_created_Month,$from_created_Day,$from_created_Year);
	$time_to_created    = mktime(23,59,59,$to_created_Month,$to_created_Day,$to_created_Year);
	$smarty_tpl->assign("time_from_created", $time_from_created);
	$smarty_tpl->assign("time_to_created", $time_to_created);
	$smarty_tpl->assign("date_created_filter", "range");
}

if ($date_closed_filter == "within") {
	$time_from_closed  	= mktime(0,0,0,date("n"),date("j")-$closed_within,date("Y"));
	$time_to_closed    	= time();
  $smarty_tpl->assign("date_closed_filter", "within");
	if (!in_array("all", $statuses) && !in_array("closed", $statuses))
		$statuses[] = "closed";
	$smarty_tpl->assign("statuses", $statuses);
}
elseif ($date_closed_filter == "range") {
	$time_from_closed  = mktime(0,0,0,$from_closed_Month,$from_closed_Day,$from_closed_Year);
	$time_to_closed    = mktime(23,59,59,$to_closed_Month,$to_closed_Day,$to_closed_Year);
	$smarty_tpl->assign("time_from_closed", $time_from_closed);
	$smarty_tpl->assign("time_to_closed", $time_to_closed);
	$smarty_tpl->assign("date_closed_filter", "range");
	if (!in_array("all", $statuses) && !in_array("closed", $statuses))
		$statuses[] = "closed";
	$smarty_tpl->assign("statuses", $statuses);
}

if ($date_lastactivity_filter == "within") {
	$time_from_last  	= mktime(0,0,0,date("n"),date("j")-$lastactivity_within,date("Y"));
	$time_to_last    	= time();
  $smarty_tpl->assign("date_lastactivity_filter", "within");
}
elseif ($date_lastactivity_filter == "range") {
	$time_from_last  = mktime(0,0,0,$from_last_Month,$from_last_Day,$from_last_Year);
	$time_to_last    = mktime(23,59,59,$to_last_Month,$to_last_Day,$to_last_Year);
	$smarty_tpl->assign("time_from_last", $time_from_last);
	$smarty_tpl->assign("time_to_last", $time_to_last);
	$smarty_tpl->assign("date_lastactivity_filter", "range");
}
if (!isset($created_within) || $created_within < 0 || !is_numeric($created_within))
  $created_within = 0;
$smarty_tpl->assign("created_within", $created_within);

if (!isset($closed_within) || $closed_within < 0 || !is_numeric($closed_within))
	$closed_within = 0;
$smarty_tpl->assign("closed_within", $closed_within);

if (!isset($lastactivity_within) || $lastactivity_within < 0 || !is_numeric($lastactivity_within))
  $lastactivity_within = 0;
$smarty_tpl->assign("lastactivity_within", $lastactivity_within);

$smarty_tpl->assign("unread", $unread);
$smarty_tpl->assign("mypost", $mypost);
$order1_options = array("last_activity"=>"Last Activity",
												"date_created"=>"Date Created",
												"subject"=>"Subject",
												"priority"=>"Priority",
												"total_replies"=>"Total Replies"
												);
$smarty_tpl->assign("order1_options", $order1_options);
$smarty_tpl->assign("order1", $order1?$order1:0);
$order2_options = array ("asc"=>"Ascending","desc"=>"Descending");
$smarty_tpl->assign("order2_options", $order2_options);
$smarty_tpl->assign("order2", $order2);

$num_tickets = count(zero::GetTickets($search_words, $search_ins, $priorities, $departments, $statuses,
	  $unread, $mypost, $time_from_created, $time_to_created, $time_from_closed, $time_to_closed,
	  $time_from_last, $time_to_last, $order1, $order2));
$smarty_tpl->assign("total_tickets", $num_tickets);
if (!is_numeric($limit) || empty($limit))
	$limit = 20;
if (!isset($offset) || $offset < 0 || $offset >= $num_tickets)
  $offset = 0;
$tickets = zero::GetTickets($search_words, $search_ins, $priorities, $departments, $statuses,
	  $unread, $mypost, $time_from_created, $time_to_created, $time_from_closed, $time_to_closed,
	  $time_from_last, $time_to_last, $order1, $order2, $offset, $limit);
if ($order1=="total_replies" && $order2=="asc")
	usort($tickets, "SortTotalRepliesAsc");
elseif ($order1=="total_replies" && $order2=="desc")
	usort($tickets, "SortTotalRepliesDesc");
$ticket_refs = explode(";",$ticket_refs);
if ($ticket_refs[0]) {
	while (list ($key, $val) = each ($tickets)) {
		if (in_array($val['ticket_ref'],$ticket_refs))
		  $tickets[$key]['checked'] = 1;
	}
}
$smarty_tpl->assign("tickets", $tickets);

$pagination	= zero::GetPagination("ticket_browse.php", $request, $num_tickets, $offset, $limit);
if (count($tickets))
	if ($num_tickets / count($tickets) > 1)
		$smarty_tpl->assign("pagination", $pagination);
$smarty_tpl->assign("limit", $limit);
$smarty_tpl->assign("offset", $offset);

$smarty_tpl->assign("page_sub_title", "- Browse Tickets");
zero::DisplayStaff("ticket_browse.tpl");

function SortTotalRepliesAsc($a, $b) {
	if ($a["num_replies"] == $b["num_replies"])
	  return $a["date_lastactivity"] < $b["date_lastactivity"];
  return $a["num_replies"] > $b["num_replies"] ? 1:-1;
}
function SortTotalRepliesDesc($a, $b) {
	if ($b["num_replies"] == $a["num_replies"])
	  return $a["date_lastactivity"] < $b["date_lastactivity"];
  return $b["num_replies"] < $a["num_replies"] ? -1:1;
}
?>
