<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006 
// |-------------------------------------------------------------|
// | File Details:
// | - Submit a ticket by staff
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}

zero::StartSession("Ticket Submit Staff");
$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];
$smarty_tpl->assign("department_options", zero::GetDepartmentOptions());
$smarty_tpl->assign("priority_options", zero::GetPriorityOptions());
$smarty_tpl->assign("priority_id", 2);
$reply_options = zero::GetPredefinedReplyOptions($staff_id);
$reply_options[0] = "------------------ Predefined Replies ------------------";
ksort ($reply_options);
$smarty_tpl->assign("reply_options", $reply_options);
$smarty_tpl->assign("replies",zero::GetDataPredefinedReply($staff_id));
$smarty_tpl->assign("subframe", 1);
$smarty_tpl->assign("subframe_title", "Ticket - submit a ticket");

zero::SetTicketCustomField();
if ($pf == "submit") {
	if (!zero::IsEmpty("email", $lang['a_empty_email']))
		zero::IsEmailFormatted("email", $lang['a_email_not_formatted']);
	zero::IsEmpty("subject", $lang['a_empty_subject']);
	zero::IsEmpty("message", $lang['a_empty_message']);
	zero::IsEmptyTicketCustomFields();
	if (zero::IsError())
	  EndScript();
	if (zero::IsBannedEmail($email))
	  EndScript();
//	if (zero::IsBannedIP($_SERVER[REMOTE_ADDR]))
//	  EndScript();
	$customfields = zero::GetGPCCustomFields();
	$ticket_ref = zero::StaffSubmitTicket($department, $priority, $email, $subject, $message, $customfields, $_SERVER[REMOTE_ADDR]);
	if (trim($reply) != "")
	  zero::StaffReplyTicket($ticket_ref, $reply, $_SERVER[REMOTE_ADDR]);
	zero::Redirect("ticket_submit.php?ticket_ref={$ticket_ref}&pf=confirm");
}
elseif ($pf == "confirm")
  GetConfirmation($ticket_ref);

$smarty_tpl->assign("page_sub_title", "- Submit a Ticket");
zero::DisplayStaff("ticket_submit.tpl");

function EndScript() {
	global $smarty_tpl, $errors;
	global $department, $priority, $email, $subject, $message;

	$smarty_tpl->assign("email", htmlentities($email));
	$smarty_tpl->assign("subject", htmlentities($subject));
	$smarty_tpl->assign("message", htmlentities($message));
	$smarty_tpl->assign("department_id", $department);
	$smarty_tpl->assign("priority_id", $priority);
	$smarty_tpl->assign("errors", $errors);
	zero::SetTicketCustomField(true);
	$smarty_tpl->assign("page_sub_title", "- Submit a Ticket");
	zero::DisplayStaff("ticket_submit.tpl");
	exit;
}

function GetConfirmation($ticket_ref) {
	global $smarty_tpl;

	$smarty_tpl->assign("subframe", 1);
	$smarty_tpl->assign("subframe_title", "Ticket - ticket has been submitted");

	$ticket = zero::GetTicket($ticket_ref);
	$ticket['message'] = nl2br($ticket['message']);
	if (!$ticket)
		zero::Redirect("ticket_submit.php");
	if (time() - $ticket['date_created'] > 300)
	  zero::Redirect("ticket_submit.php");
	$customfields = zero::GetTicketCustomFields($ticket_ref, false);
	$smarty_tpl->assign("ticket", $ticket);
	$smarty_tpl->assign("customfields", $customfields);
	$smarty_tpl->assign("confirmation", "ticket_submitted");
	$smarty_tpl->assign("page_sub_title", "- Submit a Ticket");
	zero::DisplayStaff("confirmation.tpl");
	exit;
}

?>
