<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Detail article
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}

zero::StartSession("Detail Article");
$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];
$smarty_tpl->assign("subframe", 3);
$smarty_tpl->assign("subframe_title", "Knowledgebase - article's detail");

if (!zero::IsArticleExist($knowledge_ref))
	zero::Redirect("knowledgebase_browse.php");

if ($pf=="delete_r") {
	zero::DeleteRating($id);
}
elseif ($pf == "delete_a") {
	zero::DeleteArticle($knowledge_ref);
	zero::Redirect("knowledgebase_browse.php");
}

$article = zero::GetArticle($knowledge_ref);
$article['problem'] = nl2br($article['problem']);
$smarty_tpl->assign("article", $article);
$smarty_tpl->assign("category_link", zero::GetCategoryLink($article['knowledge_cat_id']));
$smarty_tpl->assign("article_langs", zero::GetArticleOtherLang($knowledge_ref));
$smarty_tpl->assign("knowledge_ref", $knowledge_ref);
$smarty_tpl->assign("staff", zero::GetStaff($staff_id));
$limit = 7;
$request = $_SERVER[QUERY_STRING];
$num_ratings = count(zero::GetArticleRatings($knowledge_ref));
if (!isset($offset) || $offset < 0 || $offset >= $num_ratings)
  $offset = 0;
$ratings = zero::GetArticleRatings($knowledge_ref, $offset, $limit);
$smarty_tpl->assign("article_ratings", $ratings);
$smarty_tpl->assign("num_ratings", $num_ratings);
$pagination	= zero::GetPagination("knowledgebase_article_detail.php", $request, $num_ratings, $offset, $limit);
if (count($ratings))
	if ($num_ratings / count($ratings) > 1)
		$smarty_tpl->assign("pagination", $pagination);

$smarty_tpl->assign("page_sub_title", "- Article's Detail [{$article['knowledge_ref']}] ( {$article['subject']} )");
zero::DisplayStaff("knowledgebase_article_detail.tpl");

?>
