<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Edit schedule
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}

zero::StartSession("Detail Schedule");
$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];
$smarty_tpl->assign("subframe", 1);
$smarty_tpl->assign("subframe_title", "Schedule - schedule's detail");

if ($pf == "toggle") {
	zero::ToggleDoneSchedule($schedule_id);
	zero::Redirect("schedule_detail.php?schedule_id={$schedule_id}");
}
elseif ($pf == "delete") {
	zero::DeleteSchedule($schedule_id);
	zero::Redirect("schedule.php");
}

$schedule = zero::GetSchedule($schedule_id);
$smarty_tpl->assign("schedule", $schedule);
$smarty_tpl->assign("schedule_id", $schedule_id);
$smarty_tpl->assign("task_today_options", zero::GetTaskTodayOptions($staff_id));
$smarty_tpl->assign("task_due_options", zero::GetTaskDueOptions($staff_id));
$smarty_tpl->assign("page_sub_title", "- Schedule's Detail ( {$schedule['subject']} )");
zero::DisplayStaff("schedule_detail.tpl");

?>
