<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Browse staffs
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}
if (!zero::IsStaffAdmin()) {
	echo "Page cannot be access. Only admin.<br/><a href=\"index.php\">Home</a>";
	exit;
}

zero::StartSession("Browse Staff");
$smarty_tpl->assign("subframe", 2);
$smarty_tpl->assign("subframe_title", "Staff - browse staffs");

if ($pf == "delete") {
	if (isset($staff_id)) {
		zero::DeleteStaff($staff_id);
	}
}
elseif ($pf == "toggle") {
  if (isset($staff_id)) {
		zero::ToggleDisabledStaff($staff_id);
  }
}

if (!is_numeric($limit) || empty($limit))
	$limit = 20;

$request = $_SERVER[QUERY_STRING];
$num_staffs = count(zero::GetStaffs($search_words, $order1, $order2));
if (!isset($offset) || $offset < 0 || $offset >= $num_staffs )
  $offset = 0;
$staffs = zero::GetStaffs($search_words, $order1, $order2, $offset, $limit);

if ($order1=="total_posts" && $order2=="asc")
	usort($staffs, "SortPostsAsc");
elseif ($order1=="total_posts" && $order2=="desc")
	usort($staffs, "SortPostsDesc");

$smarty_tpl->assign("staffs", $staffs);
$pagination	= zero::GetPagination("staff_browse.php", $request, $num_staffs, $offset, $limit);
if (count($staffs))
	if ($num_staffs / count($staffs) > 1)
		$smarty_tpl->assign("pagination", $pagination);
$smarty_tpl->assign("search_words", $search_words);
$order1_options = array(0=>"&nbsp;",
												"date_registered"=>"Date registered",
												"email"=>"Email",
												"name"=>"Name",
												"total_posts"=>"Total posts"
												);
$order2_options = array ("asc"=>"Ascending", "desc"=>"Descending");
$smarty_tpl->assign("order1_options", $order1_options);
$smarty_tpl->assign("order1", $order1?$order1:0);
$smarty_tpl->assign("order2_options", $order2_options);
$smarty_tpl->assign("order2", $order2);
$smarty_tpl->assign("limit", $limit);
$smarty_tpl->assign("offset", $offset);

$smarty_tpl->assign("curr_staff", zero::GetStaff($_COOKIE['DESKTINY_STAFF_ID']));
$smarty_tpl->assign("page_sub_title", "- Browse Staffs");
zero::DisplayStaff("staff_browse.tpl");

function SortPostsAsc($a, $b) {
	if ($a["total_posts"] == $b["total_posts"])
	  return 0;
  return $a["total_posts"] > $b["total_posts"] ? 1:-1;
}
function SortPostsDesc($a, $b) {
	if ($b["total_posts"] == $a["total_posts"])
	  return 0;
  return $b["total_posts"] < $a["total_posts"] ? -1:1;
}

?>
