<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Ticket Custom Field Edit
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}
if (!zero::IsStaffAdmin()) {
	echo "Page cannot be access. Only admin.<br/><a href=\"index.php\">Home</a>";
	exit;
}
if (!zero::IsCustomFieldExist($field_id,'ticket'))
	zero::Redirect("custom_field_browse.php");
	
zero::StartSession("Ticket Custom Field Edit");
$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];
$smarty_tpl->assign("subframe", 1);
$smarty_tpl->assign("subframe_title", "Ticket Custom Field - Edit");

if ($pf == "update") {
	foreach ($names as $val) {
	  if (empty($val)) {
	    $errors[] = "All Field Name required";
	    break;
	  }
	}
	if ($form_type == "input") {
	  if (!$length || !is_numeric($length))
	    $length = 30;
		$height = 0;
	}
	elseif ($form_type == "textarea") {
	  if (!$length || !is_numeric($length))
	    $length = 50;
	  if (!$height || !is_numeric($height))
	    $height = 10;
	}
	if (!is_numeric($max_length))
		$max_length = 0;
	   
	if (zero::IsError())
	  EndScript();
	
	zero::UpdateCustomField("ticket",$field_id,$names,$form_type,$length,$height,$max_length,$is_required,$is_disabled);
	$smarty_tpl->assign("success", 1);
}

$field = zero::GetCustomField($field_id, 'ticket');
while (list ($key, $val) = each ($field['names'])) {
	$field['names'][$key]['value'] = htmlentities($field['names'][$key]['value']);
}
$smarty_tpl->assign("field", $field);
$smarty_tpl->assign("field_id", $field_id);
$smarty_tpl->assign("page_sub_title", "- Edit Ticket Custom Field");
zero::DisplayStaff("ticket_custom_field_edit.tpl");

function EndScript() {
	global $smarty_tpl, $errors;
	global $field_id,$names,$form_type,$length,$height,$max_length,$is_required,$is_disabled;

	$field = zero::GetCustomField($field_id, 'ticket');
	while (list ($key, $val) = each ($field['names'])) {
	  $field['names'][$key]['value'] = htmlentities($names[$val['language_id']]);
	}
	$field['form_type'] = $form_type;
	$field['length'] = $length;
	$field['height'] = $height;
	$field['max_length'] = $max_length;
	$field['is_required'] = $is_required;
	$field['is_disabled'] = $is_disabled;
	$smarty_tpl->assign("field", $field);
	$smarty_tpl->assign("field_id", $field_id);
	$smarty_tpl->assign("errors", $errors);
	$smarty_tpl->assign("page_sub_title", "- Edit Ticket Custom Field");
	zero::DisplayStaff("ticket_custom_field_edit.tpl");
	exit;
}

?>
