<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Detail and reply ticket
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}

if (!zero::IsTicketExist($ticket_ref))
	zero::Redirect("ticket_browse.php");
zero::StartSession("Detail Ticket");
$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];
$smarty_tpl->assign("subframe", 2);
$smarty_tpl->assign("subframe_title", "Ticket - ticket's detail");

$request = $_SERVER[QUERY_STRING];
if ($pf) {
 	$request = trim(preg_replace("/&pf=[\w\W]*/i", "", $request));
	if ($pf == "reply") {
		zero::IsEmpty("reply", $lang['a_empty_message']);
		if (!zero::IsError())
			zero::StaffReplyTicket($ticket_ref, $reply, $_SERVER[REMOTE_ADDR]);
	}
	elseif ($pf == "close")
	  zero::CloseTicket($ticket_ref);
	elseif ($pf == "open")
	  zero::OpenTicket($ticket_ref);
	elseif ($pf == "flag")
	  zero::FlagTicket($ticket_ref);
	elseif ($pf == "unflag")
	  zero::UnFlagTicket($ticket_ref);
	elseif ($pf == "lock")
	  zero::LockTicket($ticket_ref);
	elseif ($pf == "unlock")
	  zero::UnLockTicket($ticket_ref);
	elseif ($pf == "ban_email")
	  zero::BanEmailByTicket($ticket_ref);
	elseif ($pf == "unban_email")
	  zero::UnBanEmailByTicket($ticket_ref);
	elseif ($pf == "delete") {
	  zero::DeleteTicket($ticket_ref);
	  zero::Redirect("ticket_browse.php");
	}
	elseif ($pf == "delete_post") {
	  zero::DeleteTicketPost($post_id);
	}
	elseif ($pf == "edit_post") {
	  zero::Redirect("ticket_post_edit.php?ticket_ref={$ticket_ref}&post_id={$post_id}");
	}
	elseif ($pf == "update_priority" && $priority)
	  zero::UpdateTicketPriority($ticket_ref, $priority);
	elseif ($pf == "update_department" && $department)
	  zero::UpdateTicketDepartment($ticket_ref, $department);
	if (!zero::IsError())
		zero::Redirect("ticket_detail.php?ticket_ref={$ticket_ref}");
}

$department_options = zero::GetDepartmentOptions();
$department_options[0] = "(No change)";
ksort ($department_options);
$smarty_tpl->assign("department_options", $department_options);
$priority_options = zero::GetPriorityOptions();
$priority_options[0] = "(No change)";
ksort ($priority_options);
$smarty_tpl->assign("priority_options", $priority_options);
$reply_options = zero::GetPredefinedReplyOptions($staff_id);
$reply_options[0] = "------------------ Predefined Replies ------------------";
ksort ($reply_options);
$smarty_tpl->assign("reply_options", $reply_options);
$smarty_tpl->assign("replies",zero::GetDataPredefinedReply($staff_id));

$ticket = zero::GetTicket($ticket_ref);
$smarty_tpl->assign("ticket", $ticket);
$smarty_tpl->assign("posts", zero::GetPosts($ticket_ref));
$smarty_tpl->assign("ticket_ref", $ticket_ref);
$smarty_tpl->assign("staff", zero::GetStaff($staff_id));

if (zero::IsError()) {
	$smarty_tpl->assign("reply", $reply);
  $smarty_tpl->assign("errors", $errors);
}
zero::AddReadTicket($ticket_ref, $staff_id);
$smarty_tpl->assign("customfields", zero::GetTicketCustomFields($ticket_ref, false));
$smarty_tpl->assign("page_sub_title", "- Ticket's detail ( {$ticket['subject']} )");
zero::DisplayStaff("ticket_detail.tpl");

?>
