<?php
// |-------------------------------------------------------------|
// | Green Desktiny
// | Copyright (C) 2006
// |-------------------------------------------------------------|
// | File Details:
// | - Ticket Mass Reply
// |-------------------------------------------------------------|
require_once("init.php");
if (!zero::IsStaffLoggedIn()) {
	zero::Redirect("index.php");
	exit;
}

$staff_id = $_COOKIE['DESKTINY_STAFF_ID'];
$smarty_tpl->assign("ticket_refs", $ticket_refs);
$ticket_refs = explode(";",$ticket_refs);
$tickets = zero::GetMassTickets($ticket_refs);
if (!$tickets)
  zero::Redirect("ticket_browse.php");

zero::StartSession("Ticket Mass Reply");
$smarty_tpl->assign("subframe", 2);
$smarty_tpl->assign("subframe_title", "Ticket - Mass Reply");
if ($pf == "reply") {
	zero::IsEmpty("reply", $lang['a_empty_message']);
	if (!zero::IsError()) {
		zero::StaffReplyTickets($ticket_refs, $reply, $_SERVER[REMOTE_ADDR]);
		$smarty_tpl->assign("success", 1);
		$tickets = zero::GetMassTickets($ticket_refs);
	}
}

$reply_options = zero::GetPredefinedReplyOptions($staff_id);
$reply_options[0] = "------------------ Predefined Replies ------------------";
ksort ($reply_options);
$smarty_tpl->assign("reply_options", $reply_options);
$smarty_tpl->assign("replies",zero::GetDataPredefinedReply($staff_id));

$smarty_tpl->assign("tickets", $tickets);
$smarty_tpl->assign("staff", zero::GetStaff($staff_id));

if (zero::IsError()) {
	$smarty_tpl->assign("reply", $reply);
  $smarty_tpl->assign("errors", $errors);
}

$smarty_tpl->assign("page_sub_title", "- Mass Reply");
zero::DisplayStaff("ticket_massreply.tpl");

?>
